options pagesize=59 linesize=80 nocenter;
data one;
infile 'C:\ya06cont-469a9f57a5eab.dat' lrecl=21 missover DSD DLM=' ';
input
  CPUBID 
  Y1694200
  Y1694600
  Y1694700
  Y1701100
  ;
/*array chrrlst 
  Y1450000 -- Y1701100
  ;
do over chrrlst;
  if chrrlst = -5 then chrrlst = .A;
  if chrrlst = -4 then chrrlst = .B;
  if chrrlst = -3 then chrrlst = .C;
  if chrrlst = -2 then chrrlst = .D;
  if chrrlst = -1 then chrrlst = .E;
  end;*/
label CPUBID   = "PUBLIC ID NUMBER 2006";
label Y1694200 = "EVER CONVICTED OF ANY CHARGES? 2006";
label Y1694600 = "SPENT TIME IN JAIL/CORRECT INSTUT? 2006";
label Y1694700 = "EVER BEEN ON PROBATION? 2006";
label Y1701100 = "AGE OF YA IN YEARS AS OF 12/31/06 2006";
/* *start* Crosswalk for Reference number & Question name
    Y1450000    PUB_CASEID
    Y1694200    YASR-62A
    Y1694600    YASR-66
    Y1694700    YASR-67
    Y1701100    AGEDEC2006
      * *finish* */
      
intv2006=1;

proc sort; by cpubid;


data two;
infile 'C:\bpi6-469aa5641771d.dat' lrecl=76 missover DSD DLM=' ';
input
  CPUBID
  C0005300
  C0005400
  C0011207
  C0011209
  C0011211
  C0576100
  C0796500
  C0996500
  C1196800
  Y1176500
  Y1176900
  Y1177000
  Y1192500
  Y1417100
  Y1417500
  Y1417600
  Y1434400
  Y1668500
  Y1668900
  Y1669000
  Y1672800
  ;
/*array chrrlst 
  C0000100 -- Y1672800
  ;
do over chrrlst;
  if chrrlst = -5 then chrrlst = .A;
  if chrrlst = -4 then chrrlst = .B;
  if chrrlst = -3 then chrrlst = .C;
  if chrrlst = -2 then chrrlst = .D;
  if chrrlst = -1 then chrrlst = .E;
  if chrrlst = -7 then chrrlst = .F;
  end;*/
label CPUBID   = "ID CODE OF CHILD";
label C0005300 = "RACE OF CHILD (FROM MOTHERS SCREENER 79)";
label C0005400 = "SEX OF CHILD";
label C0011207 = "WAS CHILD INTERVWD AS YOUNG ADULT? 2000";
label C0011209 = "WAS CHILD INTERVWD AS YOUNG ADULT? 2002";
label C0011211 = "WAS CHILD INTERVWD AS YOUNG ADULT? 2004";
label C0576100 = "BPI: TOTAL STD-SAME SEX 86";
label C0796500 = "BPI: TOTAL STD-SAME SEX 88";
label C0996500 = "BPI: TOTAL STD-SAME SEX 90";
label C1196800 = "BPI: TOTAL STANDARD SCORE-SAME SEX - 92";
label Y1176500 = "EVER CONVICTED OF ANY CHARGES? 2000";
label Y1176900 = "SPENT TIME IN JAIL/CORRECT INSTUT? 2000";
label Y1177000 = "EVER BEEN ON PROBATION? 2000";
label Y1192500 = "AGE OF YA IN YEARS AS OF 12/31/00 2000";
label Y1417100 = "EVER CONVICTED OF ANY CHARGES? 2002";
label Y1417500 = "SPENT TIME IN JAIL/CORRECT INSTUT? 2002";
label Y1417600 = "EVER BEEN ON PROBATION? 2002";
label Y1434400 = "AGE OF YA IN YEARS AS OF 12/31/02 2002";
label Y1668500 = "EVER CONVICTED OF ANY CHARGES? 2004";
label Y1668900 = "SPENT TIME IN JAIL/CORRECT INSTUT? 2004";
label Y1669000 = "EVER BEEN ON PROBATION? 2004";
label Y1672800 = "AGE OF YA IN YEARS AS OF 12/31/04 2004";


data three; merge one two;
   by cpubid;

/*Limit to YAs age 20 by the end of the interview year in 2000, 2002, 2004 or 2006*/
if Y1192500=20 or Y1434400=20 or Y1672800=20 or Y1701100=20;

/*Construct yes/no variable for contact with the criminal justice system*/
cj20=0;
if Y1176500=1 or Y1176900=1 or Y1177000=1 or Y1417100=1 or Y1417500=1 or 
   Y1417600=1 or Y1668500=1 or Y1668900=1 or Y1669000=1 or Y1694200=1 or
   Y1694600=1 or Y1694700=1 then cj20=1;

/*Construct BPI at age 6 varaible*/
BPIAT6=.;
/*20 in 2006, 6 in 1992*/
if intv2006=1 and Y1701100=20 and C1196800>=0 then BPIAT6=C1196800; 
/*20 in 2004, 6 in 1990*/
if C0011211=1 and Y1672800=20 and C0996500>=0 then BPIAT6=C0996500; 
/*20 in 2002, 6 in 1988*/
if C0011209=1 and Y1434400=20 and C0796500>=0 then BPIAT6=C0796500; 
/*20 in 2000, 6 in 1986*/
if C0011207=1 and Y1192500=20 and C0576100>=0 then BPIAT6=C0576100; 

   
proc format;
  value bpif
    0-95 = 'Low'
    96-122 = 'Medium'
    123-high = 'High';

proc freq;
tables cj20*BPIAT6 / chisq measures; 
format BPIAT6 bpif.;  

run;
