options pagesize=59 linesize=120 nocenter;
data RawData;

/***********************************/
/*     Step 1:  Read in Variables  */
/***********************************/

infile 'C:\Documents and Settings\All Users\Desktop\ClusteringandWeighting\79weights.dat' dlm = ',' lrecl=158;
input ID
WGHT1979 WGHT1980 WGHT1981 WGHT1982 WGHT1983 WGHT1984
WGHT1985 WGHT1986 WGHT1987 WGHT1988 WGHT1989 WGHT1990
WGHT1991 WGHT1992 WGHT1993 WGHT1994 WGHT1996 WGHT1998
WGHT2000;

infile 'C:\Documents and Settings\All Users\Desktop\ClusteringandWeighting\79wagedata.dat' lrecl=101;
input
 R0000100  5.
 R0000600  2.
 R0214700  2.
 R0214800  2.
 R0618011  2.
 R0618012  2.
 R0618013  2.
 R0618014  2.
 R0618200  2.
 R3127800  7.
 R3401300  2.
 R3401501  2.
 R3401700  2.
 R3523500  7.
 R3656700  2.
 R3656901  2.
 R3657100  2.
 R3728500  7.
 R4007200  2.
 R4007401  2.
 R4007600  2.
 R4416800  7.
 R4418300  2.
 R4418501  2.
 R4418700  2.
 R5079800  5.
 R5081300  2.
 R5081700  2.
 R5103900  2.
 R5166600  2.
 R5166901  2.
 R5167000  2.
 R6478000  5.
 R6479200  2.
 R6479600  2.
 R6479800  2.
 ;

label R0000100 = "ID# (1-12686) 79";
label R0000600 = "AGE OF R 79";
label R0214700 = "RACL/ETHNIC COHORT /SCRNR 79";
label R0214800 = "SEX OF R 79";
label R0618011 = "PROFILES ASVAB SEC 2-STD SCRNR 81";
label R0618012 = "PROFILES ASVAB SEC 3-STD SCRNR 81";
label R0618013 = "PROFILES ASVAB SEC 4-STD SCRNR 81";
label R0618014 = "PROFILES ASVAB SEC 5-STD SCRNR 81";
label R0618200 = "PROFILES AFQT PRCTILE SCORE-80 81";
label R3127800 = "HRP CURRENT/M-RCNT JOB 90";
label R3401300 = "MARITAL STATUS (COLLAPSED) 90";
label R3401501 = "HIGHEST GRADE COMPLTD (REV) 90";
label R3401700 = "AGE OF R @ INT DATE 90";
label R3523500 = "HRP CURRENT/M-RCNT JOB 91";
label R3656700 = "MARITAL STATUS (COLLAPSED) 91";
label R3656901 = "HIGHEST GRADE COMPLTD (REV) 91";
label R3657100 = "AGE OF R @ INT DATE 91";
label R3728500 = "HRP CURRENT/M-RCNT JOB 92";
label R4007200 = "MARITAL STATUS (COLLAPSED) 92";
label R4007401 = "HIGHEST GRADE COMPLTD (REV) 92";
label R4007600 = "AGE OF R @ INT DATE 92";
label R4416800 = "HRLY RATE OF PAY CPS JOB 93";
label R4418300 = "MARITAL STATUS (COLLAPSED) 93";
label R4418501 = "HIGHEST GRADE COMPLTD (REV) 93";
label R4418700 = "AGE AT INTERVIEW DATE 93";
label R5079800 = "HRLY RATE OF PAY CPS JOB 94";
label R5081300 = "MARITAL STATUS (COLLAPSED) 94";
label R5081700 = "AGE AT INTERVIEW DATE 94";
label R5103900 = "HIGHEST GRADE COMPLTD (REV) 94";
label R5166600 = "MARITAL STATUS (COLLAPSED) 96";
label R5166901 = "HIGHEST GRADE COMPLTD (REV) 96";
label R5167000 = "AGE AT INTERVIEW DATE 96";
label R6478000 = "HRLY RATE OF PAY JOB# 1 1998";
label R6479200 = "MARITAL STATUS (COLLAPSED) 1998";
label R6479600 = "HIGHEST GRADE COMPLTD (REV) 1998";
label R6479800 = "AGE AT INTERVIEW DATE 1998";

/*****************************************************************/
/*     Step 2:  Give Variables Simple Names and Eliminate Women. */
/*****************************************************************/

TRUE  = 1;
FALSE = 0;

ID = R0000100;  /* ID# (1-12686) 79 */
Age1979 = R0000600; /* AGE OF R 79 */
Group   = R0214700; /* RACL/ETHNIC COHORT /SCRNR 79 */
if (Group =  2)
	then Black = TRUE;
	else Black = FALSE;
if (Group =  1)
	then HISPANIC = TRUE;
	else HISPANIC = FALSE;

Gender  = R0214800; /* SEX OF R 79    1 MALE     2 FEMALE  */

/* Track just males */
if (Gender = 2) then delete;

/* Handle other variables */

/* CPI (1967=100) values are as follows.  The CPI removes the effects of inflation from pay
	1990	384.4			1991	399.9			1992	411.5
	1993	423.1			1994	433.8 			1995	446.1
	1996	459.1			1997	469.3			1998	475.6
	This program uses 1991 as the base year.
*/

Pay1990     = R3127800 / (384.4 / 399.9); /* HRP CURRENT/M-RCNT JOB 90 */
Marital1990 = R3401300; /* MARITAL STATUS (COLLAPSED) 90 */
HGC1990     = R3401501; /* HIGHEST GRADE COMPLTD (REV) 90 */
Age1990     = R3401700; /* AGE OF R @ INT DATE 90 */
if (Marital1990 = 2)    /* Is R Married? */
	then Marry1990 = TRUE;
	else Marry1990 = FALSE;

Pay1991     = R3523500 / (399.9 / 399.9); /* HRP CURRENT/M-RCNT JOB 91 */
Marital1991 = R3656700; /* MARITAL STATUS (COLLAPSED) 91 */
HGC1991     = R3656901; /* HIGHEST GRADE COMPLTD (REV) 91 */
Age1991     = R3657100; /* AGE OF R @ INT DATE 91 */
if (Marital1991 = 2)    /* Is R Married? */
	then Marry1991 = TRUE;
	else Marry1991 = FALSE;

Pay1992     = R3728500 / (411.5 / 399.9); /* HRP CURRENT/M-RCNT JOB 92 */
Marital1992 = R4007200; /* MARITAL STATUS (COLLAPSED) 92 */
HGC1992     = R4007401; /* HIGHEST GRADE COMPLTD (REV) 92 */
Age1992     = R4007600; /* AGE OF R @ INT DATE 92 */
if (Marital1992 = 2)    /* Is R Married? */
	then Marry1992 = TRUE;
	else Marry1992 = FALSE;

Pay1993     = R4416800 / (423.1 / 399.9); /* HRLY RATE OF PAY CPS JOB 93 */
Marital1993 = R4418300; /* MARITAL STATUS (COLLAPSED) 93 */
HGC1993     = R4418501; /* HIGHEST GRADE COMPLTD (REV) 93 */
Age1993     = R4418700; /* AGE AT INTERVIEW DATE 93 */
if (Marital1993 = 2)    /* Is R Married? */
	then Marry1993 = TRUE;
	else Marry1993 = FALSE;

PAY1994     = R5079800 / (433.8 / 399.9); /* HRLY RATE OF PAY CPS JOB 94 */
Marital1994 = R5081300; /* MARITAL STATUS (COLLAPSED) 94 */
Age1994     = R5081700; /* AGE AT INTERVIEW DATE 94 */
HGC1994     = R5103900; /* HIGHEST GRADE COMPLTD (REV) 94 */
if (Marital1994 = 2)    /* Is R Married? */
	then Marry1994 = TRUE;
	else Marry1994 = FALSE;

Marital1996 = R5166600 / (459.1 / 399.9); /* MARITAL STATUS (COLLAPSED) 96 */
HGC1996     = R5166901; /* HIGHEST GRADE COMPLTD (REV) 96 */
Age1996     = R5167000; /* AGE AT INTERVIEW DATE 96 */
if (Marital1996 = 2)    /* Is R Married? */
	then Marry1996 = TRUE;
	else Marry1996 = FALSE;

Pay1998     = R6478000 / (475.6 / 399.9); /* HRLY RATE OF PAY JOB# 1 1998 */
Marital1998 = R6479200; /* MARITAL STATUS (COLLAPSED) 1998 */
HGC1998     = R6479600; /* HIGHEST GRADE COMPLTD (REV) 1998 */
Age1998     = R6479800; /* AGE AT INTERVIEW DATE 1998 */
if (Marital1998 = 2)    /* Is R Married? */
	then Marry1998 = TRUE;
	else Marry1998 = FALSE;

Array Pay    {1990:1998} Pay1990-Pay1998;
Do i = 1990 to 1998;
   if (Pay {i} < 0)
		then Pay {i} = .;
		else Pay {i} = Pay {i} / 100;  /* Put back two implied decimal places */
end;

proc univariate;
var Pay1994;
proc univariate;
var Pay1994;
freq wght1994;

run;
