options pagesize=59 linesize=120 nocenter mlogic mprint;
libname lib       'C:/health';

/* CDC program for calculating bmi, see http://www.cdc.gov/nccdphp/dnpa/growthcharts/sas.htm */
%let cdcPgm=   	  "C:/health/gc-calculate-BIV.sas";

/* ========================================================================== */
/*  Calculate BMI etc. using the CDC program                                  */
/* ========================================================================== */

data forCdc;  /* Pass it to the cdc dataset */
set  lib.childHtWt;

/* rename/create variables so the CDC program is happy */
agemos=ageMonth;
recumbnt=0;
headcir=.;

data _INDATA;
set forCdc;


%include &cdcPgm;

data lib.childBMI;set _INDATA; 
keep childid ageMonth male sex height heightIn weight weightOz black white hispanic momid year yob birthOrd
BMI BMIZ BMIPCT WAZ WTPCT HAZ HTPCT _BIVBMI _BIVST _BIVWT;


/* bmi too low; */
if _BIVBMI=1 then delete;
/* bmi too high; */
if _BIVBMI=2 then delete;
if _BIVBMI=. then delete;


/* height too low; */
if _BIVST=1 then delete;
/* height too high; */
if _BIVST=2 then delete;
if _BIVST=. then delete;

/* weight too low; */
if _BIVWT=1 then delete;
/* weight too high; */
if _BIVWT=2 then delete;
if _BIVWT=. then delete;

label BMI    = "Body mass index";
label BMIZ   = "BMI z-score";
label BMIPCT = "BMI percentile";
label WAZ    = "Weight z-score";
label WTPCT  = "Weight percentile";
label HAZ    = "Height z-score";
label HTPCT  = "Height percentile";
label _BIVBMI= "Biologically implausible BMI"; 
label _BIVST = "Biologically implausible Height";
label _BIVWT = "Biologically implausible Weight";

proc means;
run;
